public class Histogrammer {
    int[] counts;
    int total;
    int bins;
    double min,max;
    public Histogrammer(double min, double max, int bins)
    {
	this.bins = bins;
	this.min = min;
	this.max = max;

	total = 0;
	counts = new int[bins];
    }
    public int bin(double x)
    {
	double t = (x - min) / (max - min);
	int i = (int)Math.floor(bins * t);
	if (i<0) return 0;
	if (i>=bins) return (bins-1);
	return(i);
    }
    public void add(double x)
    {
	int i = bin(x);
	counts[i] = counts[i]+1;
	total = total + 1;
    }
    public double getBinCenter(int i)
    {
	return (min + (max-min)*(((double)i + 0.5) / bins));
    }
    public double getBinMin(int i)
    {
	return (min + (max-min)*(((double)i) / bins));
    }
    public double getBinMax(int i)
    {
	return (min + (max-min)*(((double)i + 1.0) / bins));
    }
    public int getCount(int i)
    {
	return counts[i];
    }
    public double getDensity(int i)
    {
	return ((double)counts[i] * (double)bins)/((double)total * (max-min));
    }
}
