import java.awt.*;
import java.awt.geom.*;

// Represents a chord of a triangle given a basepoint and an ideal endpoint.

class TriangleChord {
    private Complex base;
    private IdealTriangle tri; 
    private PoincareSegment chord;
    private PoincareSegment geodesic;
    private double length;

    public TriangleChord(IdealTriangle tri, Complex base, Complex ideal)
    {
	this.tri = tri;
	this.base = base;
	Complex wi = ideal;
	Complex zi = PoincareSegment.getEndpoint(ideal,base);
	geodesic = new PoincareSegment(zi,wi);
	chord = tri.getChord(geodesic);
	length = chord.getLength();
    }

    public double getLength()
    {
	return length;
    }

    public Complex getStart()
    {
	return chord.getStart();
    }

    public Complex getEnd()
    {
	return chord.getEnd();
    }

    public Complex getIdealStart()
    {
	return geodesic.getStart();
    }

    public Complex getIdealEnd()
    {
	return geodesic.getEnd();
    }

    public Complex getBase()
    {
	return base;
    }

    public void drawChordOn(Graphics2D g)
    {
	chord.drawOn(g);
    }

    public void drawGeodesicOn(Graphics2D g)
    {
	geodesic.drawOn(g);
    }
}
